#define 	F_CPU 3686400
#include	<avr/io.h>
#include  <avr/interrupt.h>

#define USART_BAUD_RATE 19200
#define USART_BAUD_SELECT (F_CPU/(USART_BAUD_RATE *16l)-1)

void usartInit(void)
{

  UCSRB |= (1<<TXEN);
  //UCSRB = (1<<RXEN) | (1<<TXEN) | (1 << RXCIE);
  UBRRH = ((unsigned char)(USART_BAUD_SELECT>>8)) & 0x80;
  UBRRL = (unsigned char) USART_BAUD_SELECT;


}

void USART_transmit (unsigned char c)
{

  while (!(UCSRA & (1<<UDRE))) {}
  UDR = c;

}


void USART_transmit_string (unsigned char *string)
{

  while (!(UCSRA & (1<<UDRE))) {}
    while ( *string)
      USART_transmit (*string++);

}

void debug(uint8_t temp)
{

        uint8_t temp2;

        temp2 = temp / 100;
        USART_transmit(temp2 + 48);

        temp -= (temp2 * 100);

        temp2 = temp / 10;
        USART_transmit(temp2 + 48);

        temp -= (temp2 * 10);

        USART_transmit(temp + 48);
        USART_transmit('\n');

}


int main()
{

  DDRB = 0xff;

  uint8_t x = 0, y = 0, z = 0, channel = 0, counter = 0;

  ADCSRA |= (1 << ADEN) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);

 // AVCC
  ADMUX |=  (1 << REFS0);

//   ADMUX |= (1 << MUX0) | (1 << MUX2);

  usartInit();
  sei();

  while(1)
  {


    //Start conversion
    ADCSRA |= (1 << ADSC);

    // wait until converstion completed
    while (ADCSRA & (1 << ADSC)) {}

    // read only the first bit
    if(ADCL & 1)
    {
       PORTB |= (1 << y);
       z |= (1 << y);
//        USART_transmit(49);
    }
    else
    {
      PORTB &= ~(1 << y);
//       USART_transmit(48);
      z &= ~(1 << y);
    }

    y++;
    if (y == 8)
    {
      y = 0;

        USART_transmit(z);
//       debug(z);
      z = 0;
    }

    //When ADCL is read, the ADC Data Register is not updated until ADCH is read.
    x = ADCH;

    // change ADC channel every 256 cycle
    counter++;
    if (counter == 0xff)
    {
      counter = 0;
      // 224 = 0b11100000
      ADMUX = channel + (ADMUX & 224);
      channel++;

      if (channel == 6)
        channel = 0;

    }
  }
}
